function traj = schnitz(t0,tf,M,P)
% function SCHNITZ is used to generate one segment of a colony using a
% stochastic simulation. It is called by the function SSACOLONY.
if nargin < 1
    m = 1;
end;

k = [1e-2 5.8e-3 6e-3 1.92e-4];

t= t0;

traj = [t M P];
while t < tf
    rates = [k(1) M*k(2) M*k(3) P*k(4)];
    tau = exprnd(1./sum(rates)); t = t + tau;
    I = cumsum(rates)/sum(rates);
    r = find(rand < I,1,'first');
    if r == 1
        M = M + 1;
    elseif r == 2
        P = P + 1;
    elseif r == 3
        M = M - 1;
    else
        P = P - 1;
    end;
    if t < tf
        traj = [traj; t M P];
    else
        foo = traj(end,:);
        traj = [traj; tf foo(2:3)];
    end;
end

end